// ignore: file_names
import 'dart:convert';
import 'package:flutter_conscent_plugin/shared_pref.dart';
import 'package:http/http.dart' as http;
import 'package:shared_preferences/shared_preferences.dart';
import 'package:uuid/uuid.dart';
import '../Model/APIMode.dart';
import '../Model/content_access_model.dart';
import '../Model/loginChallengepost.dart';
import '../Model/logout.dart';
import '../Model/subscription_access_model.dart';
import 'ConscentInitializer.dart';

class ConscentMethods {
  ContentAccessModel? contentAccessModel;
  String? loginId;

  dynamic dataMain;
  Future<ContentAccessModel?> getLoginChallengeId() async {
    final prefs = await SharedPreferences.getInstance();
    var loginId = prefs.getString('loginID');
    if (loginId == null) {
      LoginChallengepost loginChallengepost = await createLogInChallenge();
      loginId = loginChallengepost.loginChallengeId;
    }

    var responDtta = await getSessionID(loginId.toString());
    return responDtta;
  }

  Future<LoginChallengepost> createLogInChallenge() async {
    var response = await http
        .post(Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge'), body: {
      "loginChallengeId":
          '${DateTime.now().millisecondsSinceEpoch.toString()}${const Uuid().v4()}',
      "redirectTo": ""
    });
    if (response.statusCode == 201) {
      dataMains = jsonDecode(response.body);
      var responseString = response.body;
      String loginChallengeId =
          loginChallengepostFromJson(responseString).loginChallengeId;
      final prefs = await SharedPreferences.getInstance();
      await prefs.setString('loginID', loginChallengeId);
      return loginChallengepostFromJson(responseString);
    } else {
      throw Exception('Failed to create album.');
    }
  }

  Future<ContentAccessModel?> getSessionID(String loginId) async {
    var uri = Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge/$loginId');
    var response = await http.get(uri);
    if (response.statusCode == 200) {
      dataMain = jsonDecode(response.body);
      final prefs = await SharedPreferences.getInstance();
      String sessionId = dataMain['sessionId'].toString();
      prefs.setString('sessionId', sessionId);

      var responseDta = await submitDatas(
          ConscentInitializer.mClientId.toString(),
          ConscentInitializer.mContentId.toString(),
          sessionId);
      return responseDta;
    }
  }

  dynamic dataMains;
  Future<ContentAccessModel?> submitDatas(
    String clientId,
    String clientContentId,
    String sessionId,
  ) async {
    var response = await http
        .post(Uri.parse('${APIMode.BASE_URL}api/v1/content/access'), body: {
      "clientId": clientId,
      "clientContentId": clientContentId,
      "sessionId": sessionId,
    });

    if (response.statusCode == 201) {
      dataMains = jsonDecode(response.body);
      contentAccessModel = ContentAccessModel.fromJson(dataMains);
      return contentAccessModel;
    }
    return null;
  }

  Future<String?> getSessionIDs() async {
    var prefs = await SharedPreferences.getInstance();
    var isLogin = prefs.getString('loginID');
    return prefs.getString('sessionId');
  }

  Future<String?> isLogin() async {
    var prefs = await SharedPreferences.getInstance();
    var isLogin = prefs.getString('loginID');
    return isLogin;
  }

  // methods for subscription
  Future<Subscription_Access?> getLoginChallengeIdForSubs() async {
    final prefs = await SharedPreferences.getInstance();
    loginId = prefs.getString('loginID');

    var responDtta = await getSessionIDForSubs(loginId.toString());
    return responDtta;
  }

//GetsSession
  Future<Subscription_Access?> getSessionIDForSubs(String loginId) async {
    var uri = Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge/$loginId');
    var response = await http.get(uri);
    if (response.statusCode == 200) {
      dataMain = jsonDecode(response.body);
      final prefs = await SharedPreferences.getInstance();
      String sessionId = dataMain['sessionId'].toString();
      prefs.setString('sessionId', sessionId);
      var responseDta = await getPstssForSubs();
      return responseDta;
    }
    return null;
  }

//getsPstssforSunscribtion
  Future<Subscription_Access?> getPstssForSubs() async {
    final prefs = await SharedPreferences.getInstance();
    var sessionIds = prefs.getString('sessionId');
    var uri = Uri.parse(
        '${APIMode.BASE_URL}api/v1/subscription/access?sessionId=$sessionIds'
        '&'
        'clientId=${ConscentInitializer.mClientId}');
    var response = await http.get(uri);
    if (response.statusCode == 200) {
      dataMains = jsonDecode(response.body);
      var subscriptionAccess = Subscription_Access.fromJson(dataMains);
      return subscriptionAccess;
    }
    return null;
  }

  // logout
  dynamic dataMainlogout;
  Future<Logout> userLogOut(String sessionId) async {
    String? sessionId = await SharedPref().getSessionId();
    var response = await http.post(
        Uri.parse(
            '${APIMode.BASE_URL}api/v1/auth/logout-via-sessionid?sessionId=$sessionId'),
        body: {
          "sessionId": sessionId,
        });
    if (response.statusCode == 201) {
      dataMainlogout = jsonDecode(response.body);
      var responseString = response.body;
      return logoutFromJson(responseString);
    } else {
      throw Exception('Failed to create album.');
    }
  }

  //getUser()
  dynamic getusermain;

  Future<dynamic> getUser() async {
    final prefs = await SharedPreferences.getInstance();
    String? sessionId = await SharedPref().getSessionId();
    sessionId = prefs.getString('sessionId');

    var uri = Uri.parse(
        '${APIMode.BASE_URL}api/v1/user/$sessionId?clientId=${ConscentInitializer.mClientId}');

    var response = await http.get(uri);

    if (response.statusCode == 200) {
      getusermain = jsonDecode(response.body);
      return getusermain;
    }
  }
}
