// // ignore_for_file: file_names

import 'dart:convert';
import 'dart:io' show Platform;
import 'package:flutter_conscent_plugin/Model/embeddedModel.dart';
import 'package:flutter_conscent_plugin/Model/embeddedSubscribtion.dart';
import 'package:flutter_conscent_plugin/Model/loginChallengepost.dart';
import 'package:flutter_conscent_plugin/webviews.dart';
import 'package:flutter_conscent_plugin/Model/PaywallViewEvent.dart';
import 'package:fk_user_agent/fk_user_agent.dart';
import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;
import 'package:shared_preferences/shared_preferences.dart';
import 'package:uuid/uuid.dart';
import 'package:intl/intl.dart';
import '../Model/APIMode.dart';
import 'ConscentInitializer.dart';
import 'package:flutter/services.dart';

var messageBodyData = MessageBody();

// ignore: must_be_immutable
class EmbeddedSub extends StatefulWidget {
  Function(String) sessionCallback;
  EmbeddedSub(this.sessionCallback, {Key? key}) : super(key: key);

  @override
  State<EmbeddedSub> createState() => SubscribeState();
}

String loginChallengeId = "loginChallengeId";
String sessionId = "sessionId";

class SubscribeState extends State<EmbeddedSub> {
  dynamic dataMain;
  bool buttonenabled = true;

//LoginChallengepost
  Future<LoginChallengepost> submitDatas(
      String loginChallengeId, String redirectTo) async {
    var response = await http
        .post(Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge'), body: {
      "loginChallengeId":
          '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4().toString()}',
      "redirectTo": redirectTo
    });
    if (response.statusCode == 201) {
      dataMain = jsonDecode(response.body);
      var responseString = response.body;
      String loginChallengeId =
          loginChallengepostFromJson(responseString).loginChallengeId;
      final prefs = await SharedPreferences.getInstance();
      await prefs.setString('loginID', loginChallengeId);
      return loginChallengepostFromJson(responseString);
    } else {
      throw Exception('Failed to create album.');
    }
  }

  clearData() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.clear();
  }

  tryAutoLogin() async {
    var any = await SharedPreferences.getInstance();
    if (!any.containsKey("loginChallengeId")) {
      return false;
    } else {
      return true;
    }
  }

  var uuid =
      '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}';
  int i = 0;
  int selected = 0;
  List result = [];
  bool isWoman = true;
  var dummy;
  var tierId = "";
  Embedded? model;
  final loginChallengeId = TextEditingController();
  final redirectTo = TextEditingController();
  bool isLoaded = false;

//embedded-subscription
  doOnLaunch() async {
    var response = await http.get(Uri.parse(
        "${APIMode.BASE_URL}api/v1/subscription/embedded-subscription?clientId=${ConscentInitializer.mClientId}"));
    result = jsonDecode(response.body)["subscriptions"];
    dummy = jsonDecode(response.body);
    model = Embedded.fromJson(dummy);
    tierId = result[i]['tiers'][0]['offers'][0]['_id'];
    setState(() {
      isLoaded = true;
    });
  }

  //subsciption access
  dynamic dataMains;
  getPtssss() async {
    final prefs = await SharedPreferences.getInstance();
    sessionId = prefs.getString('sessionId') ?? "sessionId";
    var sessionIds = prefs.getString('sessionId');
    var uri = Uri.parse(
        '${APIMode.BASE_URL}api/v1/subscription/access?sessionId=$sessionIds' +
            'clientId=${ConscentInitializer.mClientId}');
    var response = await http.get(uri);
    if (response.statusCode == 200) {
      dataMains = jsonDecode(response.body);
      setState(() {});
    } else {
      throw Exception('Failed to load album');
    }
  }

  // ignore: prefer_typing_uninitialized_variables
  var controller;
  // ignore: prefer_typing_uninitialized_variables
  var data;
  bool isPressed = false;
  int pageIndex = 0;

  Widget Bullet() {
    {
      return Container(
        height: 5,
        width: 5,
        decoration: const BoxDecoration(
          color: Color.fromRGBO(162, 32, 38, 1.0),
          shape: BoxShape.circle,
        ),
      );
    }
  }

  List<String> benefitsList() {
    if (result[i] == null) {
      return result[i]["benefits"].split(',').toList();
    }
    return result[i]["benefits"].split(',').toList();
  }

  // ignore: non_constant_identifier_names
  Widget BulletMark() {
    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      crossAxisAlignment: CrossAxisAlignment.center,
      children: <Widget>[
        for (var line in benefitsList()) styleline(line),
      ],
    );
  }

  Widget styleline(String line) {
    return SizedBox(
        height: 38,
        child: Row(children: [
          Bullet(),
          const SizedBox(
            width: 40,
          ),
          Text(
            line,
            style: const TextStyle(fontSize: 18, fontWeight: FontWeight.normal),
          ),
        ]));
  }

  bool active = true;

  Widget homeBody() {
    if (!isLoaded) {
      return const CircularProgressIndicator();
    } else {
      return Padding(
        padding: const EdgeInsets.all(8.0),
        child: Column(
          children: [
            Row(
              mainAxisAlignment: MainAxisAlignment.center,
              crossAxisAlignment: CrossAxisAlignment.center,
              children: [
                Visibility(
                    visible: dummy["subscriptions"].length == 1 ||
                            i > 0 == dummy["subscriptions"].length - 1
                        ? false
                        : true,
                    child: Column(
                      children: [
                        IconButton(
                            onPressed: i > 0 && i > 0
                                ? () {
                                    selected = 0;
                                    setState(() {
                                      buttonenabled = true;
                                      i--;
                                    });
                                  }
                                : null,
                            icon: const Icon(Icons.arrow_back_ios)),
                      ],
                    )),
                Expanded(
                    child: Container(
                        height: result[i]["tiers"].length > 4 ? 400 : 220,
                        child: Center(
                          child: GridView.builder(
                              itemCount: result.isNotEmpty
                                  ? result[i]["tiers"].length
                                  : 0,
                              gridDelegate:
                                  const SliverGridDelegateWithFixedCrossAxisCount(
                                      crossAxisCount: 2,
                                      mainAxisSpacing: 8,
                                      crossAxisSpacing: 8,
                                      childAspectRatio: 1.6),
                              itemBuilder: (context, index) {
                                var basePrice =
                                    result[i]["tiers"][index]["basePrice"];
                                String percent = '';

                                if (basePrice != 0) {
                                  percent =
                                      "${(100 - ((result[i]["tiers"][index]["price"] / basePrice) * 100)).toStringAsFixed(0)}% off";
                                }
                                return InkWell(
                                  onTap: () {
                                    setState(() {
                                      selected = index;
                                    });
                                  },
                                  child: Padding(
                                    padding: const EdgeInsets.all(0.0),
                                    child: Container(
                                      decoration: BoxDecoration(
                                        border: Border.all(
                                          color: selected == index
                                              ? Color.fromRGBO(171, 58, 53, 1.0)
                                              : const Color.fromRGBO(
                                                  221, 221, 221, 1.0),
                                          width: 2,
                                        ),
                                        borderRadius: BorderRadius.circular(10),
                                      ),
                                      child: Padding(
                                        padding: const EdgeInsets.symmetric(
                                            horizontal: 10, vertical: 5),
                                        child: Center(
                                          child: Column(
                                            mainAxisAlignment:
                                                MainAxisAlignment.center,
                                            crossAxisAlignment:
                                                CrossAxisAlignment.center,
                                            children: [
                                              Row(
                                                mainAxisAlignment:
                                                    MainAxisAlignment.center,
                                                crossAxisAlignment:
                                                    CrossAxisAlignment.center,
                                                children: [
                                                  Text(
                                                    result[i]["tiers"][index][
                                                                    "basePrice"]
                                                                .toString() ==
                                                            "0"
                                                        ? ""
                                                        : "₹${result[i]["tiers"][index]["basePrice"]} ",
                                                    style: TextStyle(
                                                        decoration:
                                                            TextDecoration
                                                                .lineThrough,
                                                        fontSize: 15,
                                                        color: selected == index
                                                            ? Colors.grey
                                                            : Colors.grey),
                                                  ),
                                                  if (result[i]['tiers'][index]
                                                          ['basePrice'] !=
                                                      0)
                                                    Text(
                                                      percent.toString(),
                                                      style: const TextStyle(
                                                        color: Colors.red,
                                                      ),
                                                    ),
                                                ],
                                              ),
                                              Text(
                                                "₹${result[i]["tiers"][index]["price"]}.00",
                                                style: TextStyle(
                                                    fontSize: 20,
                                                    fontWeight: FontWeight.bold,
                                                    color: selected == index
                                                        ? Colors.black
                                                        : Colors.black),
                                              ),
                                              Text(
                                                "${result[i]["tiers"][index]["duration"]} month",
                                                style: TextStyle(
                                                    fontSize: 17,
                                                    color: selected == index
                                                        ? Colors.black
                                                        : Colors.black),
                                              ),
                                            ],
                                          ),
                                        ),
                                      ),
                                    ),
                                  ),
                                );
                              }),
                        ))),
                Visibility(
                    visible: dummy["subscriptions"].length == 1 ||
                            i == dummy["subscriptions"].length - 1
                        ? false
                        : true,
                    child: Column(
                      children: [
                        IconButton(
                            onPressed: i < dummy["subscriptions"].length - 1 &&
                                    i != dummy["subscriptions"].length
                                ? () {
                                    setState(() {
                                      selected = 0;

                                      buttonenabled = false;
                                      i++;
                                    });
                                  }
                                : null,
                            icon: const Icon(Icons.arrow_forward_ios)),
                      ],
                    )),
              ],
            ),
            const Text(
              "Benefits: You will Get",
              textAlign: TextAlign.center,
              style: TextStyle(fontSize: 22, fontWeight: FontWeight.bold),
            ),
            const SizedBox(
              height: 10,
            ),
            SizedBox(child: BulletMark()),
            const SizedBox(
              height: 25,
            ),
            result[i] != null && result[i]["freeTrial"]["duration"] == null
                ? const SizedBox()
                : Row(
                    mainAxisAlignment: MainAxisAlignment.center,
                    crossAxisAlignment: CrossAxisAlignment.center,
                    children: [
                      Checkbox(
                        value: isWoman,
                        checkColor: Colors.white,
                        activeColor: const Color.fromRGBO(162, 32, 38, 1.0),
                        onChanged: (value) {
                          setState(() {
                            isWoman = value!;
                          });
                        },
                      ),
                      Text(
                          "Start your ${result[i]["freeTrial"]["duration"].toString()}-days",
                          style: const TextStyle(
                              fontSize: 16, fontWeight: FontWeight.bold),
                          textAlign: TextAlign.center),
                      const Text(
                        " Free",
                        style: TextStyle(
                            fontSize: 16,
                            color: Color.fromRGBO(162, 32, 38, 1.0),
                            fontWeight: FontWeight.bold),
                      ),
                      const Text(
                        " Trail",
                        style: TextStyle(
                            fontSize: 16, fontWeight: FontWeight.bold),
                      ),
                    ],
                  )
          ],
        ),
      );
    }
  }

  @override
  Widget build(BuildContext context) {
    var data;
    bool isPressed = false;

    return SafeArea(
      child: Scaffold(
        body: Center(
          child: Card(
            child: SingleChildScrollView(
              child: Column(
                mainAxisSize: MainAxisSize.min,
                children: <Widget>[
                  ListTile(
                    tileColor: Color.fromRGBO(162, 32, 38, 1.0),
                    title: Text(
                      style: const TextStyle(
                          color: Colors.white,
                          fontSize: 16,
                          fontWeight: FontWeight.bold),
                      dummy != null ? ' ${dummy["title"]}' : "",
                      textAlign: TextAlign.center,
                    ),
                  ),
                  const ListTile(
                    title: Text(
                      'Choose Plan',
                      textAlign: TextAlign.center,
                      style:
                          TextStyle(fontSize: 22, fontWeight: FontWeight.bold),
                    ),
                  ),
                  Container(
                    child: homeBody(),
                  ),
                  ElevatedButton(
                    onPressed: () {
                      submitDatas(loginChallengeId.text, redirectTo.text)
                          .then((value) {
                        Navigator.push(
                          context,
                          MaterialPageRoute(
                              builder: (context) => WebViewApps(
                                  tiersId: model?.subscriptions?[i]
                                          .tiers?[selected].sId ??
                                      "",
                                  isWoman: isWoman)),
                        ).then((value) {
                          if (value != null) {
                            dynamic response = value['response'];
                            widget.sessionCallback(response);
                          }
                        });
                      });
                    },
                    style: ElevatedButton.styleFrom(
                      primary: Colors.black,
                      minimumSize: const Size(300, 50),
                      shape: const StadiumBorder(),
                    ),
                    child: const Text(
                      'Subscribe',
                    ),
                  ),
                ],
              ),
            ),
          ),
        ),
      ),
    );
  }

  @override
  void initState() {
    controller = PageController(initialPage: pageIndex);
    doOnLaunch();
    super.initState();
    WidgetsBinding.instance.addPostFrameCallback((timeStamp) async {
      await FkUserAgent.init();
      initPlatformState();
    });

    if (Platform.isAndroid) {
      messageBodyData.osName = "Android";
    } else if (Platform.isIOS) {
      messageBodyData.osName = "Iphone";
    }
    paywallViewEvent();
  }

  Future<void> paywallViewEvent() async {
    var uuid =
        '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}';

    DateFormat dateFormat = DateFormat("yyyy-MM-dd HH:mm:ss");
    String createdAt = dateFormat.format(DateTime.now());

    messageBodyData.id = uuid;
    messageBodyData.createdAt = createdAt;
    messageBodyData.updatedAt = createdAt;
    messageBodyData.deviceType = "Mobile";
    messageBodyData.eventLocation = "PAYWALL";
    messageBodyData.eventType = "VIEW";
    messageBodyData.isCookieBlocked = 0;
    messageBodyData.paywallId = "Embedded";
    messageBodyData.numOfCta = 1;

    var paywallViewEvent = PaywallViewEvent(messageBody: [messageBodyData]);
    paywallViewEvent.topic = "demoTopic";
  }

  Future<void> initPlatformState() async {
    String platformVersion;
    try {
      platformVersion = FkUserAgent.userAgent!;
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }
    messageBodyData.userAgent = "${FkUserAgent.webViewUserAgent}";
    messageBodyData.osVersion = "${FkUserAgent.userAgent}";
    messageBodyData.mobileModel = platformVersion;
    if (!mounted) return;
  }

  @override
  void dispose() {
    controller.dispose();
    super.dispose();
  }
}
