// To parse this JSON data, do

import 'dart:convert';

Signature signatureFromJson(String str) => Signature.fromJson(json.decode(str));

String signatureToJson(Signature data) => json.encode(data.toJson());

class Signature {
  Signature({
    required this.subscriptionAlreadyPurchased,
    required this.purchasedSubscriptions,
    required this.freeTrialConsumed,
    required this.allowRenewal,
    required this.internalUser,
    required this.payload,
    required this.consumptionId,
    required this.signature,
    required this.downloadExists,
  });

  bool subscriptionAlreadyPurchased;
  List<PurchasedSubscription> purchasedSubscriptions;
  bool freeTrialConsumed;
  bool allowRenewal;
  bool internalUser;
  Payload payload;
  String consumptionId;
  String signature;
  bool downloadExists;

  factory Signature.fromJson(Map<String, dynamic> json) => Signature(
        subscriptionAlreadyPurchased: json["subscriptionAlreadyPurchased"],
        purchasedSubscriptions: List<PurchasedSubscription>.from(
            json["purchasedSubscriptions"]
                .map((x) => PurchasedSubscription.fromJson(x))),
        freeTrialConsumed: json["freeTrialConsumed"],
        allowRenewal:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["allowRenewal"] == null ? null : json["allowRenewal"],
        internalUser:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["internalUser"] == null ? null : json["internalUser"],
        payload: Payload.fromJson(json["payload"]),
        consumptionId:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["consumptionId"] == null ? null : json["consumptionId"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        signature: json["signature"] == null ? null : json["signature"],
        downloadExists:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["downloadExists"] == null ? null : json["downloadExists"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "subscriptionAlreadyPurchased": subscriptionAlreadyPurchased == null
            ? null
            : subscriptionAlreadyPurchased,
        "purchasedSubscriptions": purchasedSubscriptions == null
            ? null
            : List<dynamic>.from(purchasedSubscriptions.map((x) => x.toJson())),
        "freeTrialConsumed":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            freeTrialConsumed == null ? null : freeTrialConsumed,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "allowRenewal": allowRenewal == null ? null : allowRenewal,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "internalUser": internalUser == null ? null : internalUser,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "payload": payload == null ? null : payload.toJson(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "consumptionId": consumptionId == null ? null : consumptionId,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "signature": signature == null ? null : signature,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "downloadExists": downloadExists == null ? null : downloadExists,
      };
}

class Payload {
  Payload({
    required this.clientId,
    required this.subscriptionId,
    required this.createdAt,
  });

  String clientId;
  String subscriptionId;
  DateTime createdAt;

  factory Payload.fromJson(Map<String, dynamic> json) => Payload(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        clientId: json["clientId"] == null ? null : json["clientId"],
        subscriptionId:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["subscriptionId"] == null ? null : json["subscriptionId"],
        createdAt: DateTime.parse(json["createdAt"]),
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "clientId": clientId == null ? null : clientId,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "subscriptionId": subscriptionId == null ? null : subscriptionId,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "createdAt": createdAt == null ? null : createdAt.toIso8601String(),
      };
}

class PurchasedSubscription {
  PurchasedSubscription({
    required this.purchasedDate,
    required this.validity,
    required this.priceDetails,
    required this.offerDetails,
    required this.subscription,
    required this.subscriptionDetails,
  });

  String purchasedDate;
  String validity;
  PriceDetails priceDetails;
  List<dynamic> offerDetails;
  Subscription subscription;
  SubscriptionDetails subscriptionDetails;

  factory PurchasedSubscription.fromJson(Map<String, dynamic> json) =>
      PurchasedSubscription(
        purchasedDate:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["purchasedDate"] == null ? null : json["purchasedDate"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        validity: json["validity"] == null ? null : json["validity"],
        priceDetails: PriceDetails.fromJson(json["priceDetails"]),
        offerDetails: List<dynamic>.from(json["offerDetails"].map((x) => x)),
        subscription: Subscription.fromJson(json["subscription"]),
        subscriptionDetails:
            SubscriptionDetails.fromJson(json["subscriptionDetails"]),
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "purchasedDate": purchasedDate == null ? null : purchasedDate,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "validity": validity == null ? null : validity,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "priceDetails": priceDetails == null ? null : priceDetails.toJson(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "offerDetails": offerDetails == null
            ? null
            : List<dynamic>.from(offerDetails.map((x) => x)),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "subscription": subscription == null ? null : subscription.toJson(),
        "subscriptionDetails":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            subscriptionDetails == null ? null : subscriptionDetails.toJson(),
      };
}

class PriceDetails {
  PriceDetails({
    required this.amount,
    required this.currency,
  });

  int amount;
  String currency;

  factory PriceDetails.fromJson(Map<String, dynamic> json) => PriceDetails(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        amount: json["amount"] == null ? null : json["amount"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        currency: json["currency"] == null ? null : json["currency"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "amount": amount == null ? null : amount,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "currency": currency == null ? null : currency,
      };
}

class Subscription {
  Subscription({
    required this.tierId,
    required this.digital,
    required this.physical,
    required this.adFree,
    required this.title,
    required this.renew,
    required this.duration,
    required this.durationText,
  });

  String tierId;
  bool digital;
  bool physical;
  bool adFree;
  String title;
  bool renew;
  int duration;
  String durationText;

  factory Subscription.fromJson(Map<String, dynamic> json) => Subscription(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        tierId: json["tierId"] == null ? null : json["tierId"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        digital: json["digital"] == null ? null : json["digital"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        physical: json["physical"] == null ? null : json["physical"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        adFree: json["adFree"] == null ? null : json["adFree"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        title: json["title"] == null ? null : json["title"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        renew: json["renew"] == null ? null : json["renew"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        duration: json["duration"] == null ? null : json["duration"],
        durationText:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["durationText"] == null ? null : json["durationText"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "tierId": tierId == null ? null : tierId,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "digital": digital == null ? null : digital,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "physical": physical == null ? null : physical,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "adFree": adFree == null ? null : adFree,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "title": title == null ? null : title,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "renew": renew == null ? null : renew,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "duration": duration == null ? null : duration,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "durationText": durationText == null ? null : durationText,
      };
}

class SubscriptionDetails {
  SubscriptionDetails({
    required this.freeTrial,
    required this.benefits,
    required this.physical,
    required this.digital,
    required this.adFree,
    required this.migrated,
    required this.couponsEnabled,
    required this.adminCoupon,
    required this.usedCouponNumbers,
    required this.id,
    required this.recommended,
    required this.enabled,
    required this.clientId,
    required this.title,
    required this.iconUrl,
    required this.tiers,
    required this.createdAt,
    required this.updatedAt,
    required this.v,
    required this.couponCount,
    required this.currencySymbol,
  });

  FreeTrial freeTrial;
  String benefits;
  bool physical;
  bool digital;
  bool adFree;
  bool migrated;
  bool couponsEnabled;
  String adminCoupon;
  List<dynamic> usedCouponNumbers;
  String id;
  bool recommended;
  bool enabled;
  String clientId;
  String title;
  String iconUrl;
  List<Tier> tiers;
  DateTime createdAt;
  DateTime updatedAt;
  int v;
  int couponCount;
  String currencySymbol;

  factory SubscriptionDetails.fromJson(Map<String, dynamic> json) =>
      SubscriptionDetails(
        freeTrial: FreeTrial.fromJson(json["freeTrial"]),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        benefits: json["benefits"] == null ? null : json["benefits"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        physical: json["physical"] == null ? null : json["physical"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        digital: json["digital"] == null ? null : json["digital"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        adFree: json["adFree"] == null ? null : json["adFree"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        migrated: json["migrated"] == null ? null : json["migrated"],
        couponsEnabled:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["couponsEnabled"] == null ? null : json["couponsEnabled"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        adminCoupon: json["adminCoupon"] == null ? null : json["adminCoupon"],
        usedCouponNumbers:
            List<dynamic>.from(json["usedCouponNumbers"].map((x) => x)),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        id: json["_id"] == null ? null : json["_id"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        recommended: json["recommended"] == null ? null : json["recommended"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        enabled: json["enabled"] == null ? null : json["enabled"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        clientId: json["clientId"] == null ? null : json["clientId"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        title: json["title"] == null ? null : json["title"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        iconUrl: json["iconUrl"] == null ? null : json["iconUrl"],
        tiers: List<Tier>.from(json["tiers"].map((x) => Tier.fromJson(x))),
        createdAt: DateTime.parse(json["createdAt"]),
        updatedAt: DateTime.parse(json["updatedAt"]),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        v: json["__v"] == null ? null : json["__v"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        couponCount: json["couponCount"] == null ? null : json["couponCount"],
        currencySymbol:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["currencySymbol"] == null ? null : json["currencySymbol"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "freeTrial": freeTrial == null ? null : freeTrial.toJson(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "benefits": benefits == null ? null : benefits,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "physical": physical == null ? null : physical,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "digital": digital == null ? null : digital,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "adFree": adFree == null ? null : adFree,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "migrated": migrated == null ? null : migrated,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "couponsEnabled": couponsEnabled == null ? null : couponsEnabled,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "adminCoupon": adminCoupon == null ? null : adminCoupon,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "usedCouponNumbers": usedCouponNumbers == null
            ? null
            : List<dynamic>.from(usedCouponNumbers.map((x) => x)),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "_id": id == null ? null : id,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "recommended": recommended == null ? null : recommended,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "enabled": enabled == null ? null : enabled,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "clientId": clientId == null ? null : clientId,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "title": title == null ? null : title,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "iconUrl": iconUrl == null ? null : iconUrl,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "tiers": tiers == null
            ? null
            : List<dynamic>.from(tiers.map((x) => x.toJson())),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "createdAt": createdAt == null ? null : createdAt.toIso8601String(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "updatedAt": updatedAt == null ? null : updatedAt.toIso8601String(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "__v": v == null ? null : v,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "couponCount": couponCount == null ? null : couponCount,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "currencySymbol": currencySymbol == null ? null : currencySymbol,
      };
}

class FreeTrial {
  FreeTrial({
    required this.enabled,
    required this.duration,
  });

  bool enabled;
  int duration;

  factory FreeTrial.fromJson(Map<String, dynamic> json) => FreeTrial(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        enabled: json["enabled"] == null ? null : json["enabled"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        duration: json["duration"] == null ? null : json["duration"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "enabled": enabled == null ? null : enabled,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "duration": duration == null ? null : duration,
      };
}

class Tier {
  Tier({
    required this.priceOverrides,
    required this.currency,
    required this.basePrice,
    required this.offers,
    required this.id,
    required this.price,
    required this.duration,
  });

  PriceOverrides priceOverrides;
  String currency;
  double basePrice;
  List<Offer> offers;
  String id;
  int price;
  int duration;

  factory Tier.fromJson(Map<String, dynamic> json) => Tier(
        priceOverrides: PriceOverrides.fromJson(json["priceOverrides"]),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        currency: json["currency"] == null ? null : json["currency"],
        basePrice:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["basePrice"] == null ? null : json["basePrice"].toDouble(),
        offers: List<Offer>.from(json["offers"].map((x) => Offer.fromJson(x))),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        id: json["_id"] == null ? null : json["_id"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        price: json["price"] == null ? null : json["price"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        duration: json["duration"] == null ? null : json["duration"],
      );

  Map<String, dynamic> toJson() => {
        "priceOverrides":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            priceOverrides == null ? null : priceOverrides.toJson(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "currency": currency == null ? null : currency,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "basePrice": basePrice == null ? null : basePrice,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "offers": offers == null
            ? null
            : List<dynamic>.from(offers.map((x) => x.toJson())),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "_id": id == null ? null : id,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "price": price == null ? null : price,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "duration": duration == null ? null : duration,
      };
}

class Offer {
  Offer({
    required this.id,
    required this.title,
    required this.benefits,
    required this.iconUrl,
  });

  String id;
  String title;
  String benefits;
  String iconUrl;

  factory Offer.fromJson(Map<String, dynamic> json) => Offer(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        id: json["_id"] == null ? null : json["_id"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        title: json["title"] == null ? null : json["title"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        benefits: json["benefits"] == null ? null : json["benefits"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        iconUrl: json["iconUrl"] == null ? null : json["iconUrl"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "_id": id == null ? null : id,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "title": title == null ? null : title,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "benefits": benefits == null ? null : benefits,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "iconUrl": iconUrl == null ? null : iconUrl,
      };
}

class PriceOverrides {
  PriceOverrides({
    required this.country,
  });

  List<dynamic> country;

  factory PriceOverrides.fromJson(Map<String, dynamic> json) => PriceOverrides(
        country: List<dynamic>.from(json["country"].map((x) => x)),
      );

  Map<String, dynamic> toJson() => {
        "country":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            country == null ? null : List<dynamic>.from(country.map((x) => x)),
      };
}
