// To parse this JSON data, do
//

import 'dart:convert';

ContentDetails contentDetailsFromJson(String str) =>
    ContentDetails.fromJson(json.decode(str));

String contentDetailsToJson(ContentDetails data) => json.encode(data.toJson());

class ContentDetails {
  ContentDetails({
    required this.microPricing,
    required this.price,
    required this.duration,
    required this.currency,
    required this.currencySymbol,
    required this.clientName,
    required this.url,
    required this.title,
    required this.contentType,
    required this.couponDetails,
    required this.downloadExists,
    required this.bundle,
    required this.pixels,
    required this.logoUrl,
    required this.validPass,
    required this.paywallCustomization,
    required this.subscriptionsExist,
    required this.subscriptionDomain,
    required this.pathUrl,
    required this.categories,
    required this.detectedCountry,
    required this.couponForPass,
    required this.subscriptionUrl,
  });

  MicroPricing microPricing;
  int price;
  int duration;
  String currency;
  String currencySymbol;
  String clientName;
  String url;
  String title;
  String contentType;
  Coupon couponDetails;
  bool downloadExists;
  bool bundle;
  Pixels pixels;
  String logoUrl;
  ValidPass validPass;
  PaywallCustomization paywallCustomization;
  bool subscriptionsExist;
  String subscriptionDomain;
  String pathUrl;
  List<dynamic> categories;
  String detectedCountry;
  Coupon couponForPass;
  String subscriptionUrl;

  factory ContentDetails.fromJson(Map<String, dynamic> json) => ContentDetails(
        microPricing: MicroPricing.fromJson(json["microPricing"]),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        price: json["price"] == null ? null : json["price"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        duration: json["duration"] == null ? null : json["duration"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        currency: json["currency"] == null ? null : json["currency"],
        currencySymbol:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            json["currencySymbol"] == null ? null : json["currencySymbol"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        clientName: json["clientName"] == null ? null : json["clientName"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        url: json["url"] == null ? null : json["url"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        title: json["title"] == null ? null : json["title"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        contentType: json["contentType"] == null ? null : json["contentType"],
        couponDetails: Coupon.fromJson(json["couponDetails"]),
        downloadExists:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            json["downloadExists"] == null ? null : json["downloadExists"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        bundle: json["bundle"] == null ? null : json["bundle"],
        pixels: Pixels.fromJson(json["pixels"]),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        logoUrl: json["logoUrl"] == null ? null : json["logoUrl"],
        validPass: ValidPass.fromJson(json["validPass"]),
        paywallCustomization:
            PaywallCustomization.fromJson(json["paywallCustomization"]),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        subscriptionsExist: json["subscriptionsExist"] == null
            ? null
            : json["subscriptionsExist"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        subscriptionDomain: json["subscriptionDomain"] == null
            ? null
            : json["subscriptionDomain"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        pathUrl: json["pathUrl"] == null ? null : json["pathUrl"],
        categories: List<dynamic>.from(json["categories"].map((x) => x)),
        detectedCountry:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            json["detectedCountry"] == null ? null : json["detectedCountry"],
        couponForPass: Coupon.fromJson(json["couponForPass"]),
        subscriptionUrl:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            json["subscriptionUrl"] == null ? null : json["subscriptionUrl"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "microPricing": microPricing == null ? null : microPricing.toJson(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "price": price == null ? null : price,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "duration": duration == null ? null : duration,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "currency": currency == null ? null : currency,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "currencySymbol": currencySymbol == null ? null : currencySymbol,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "clientName": clientName == null ? null : clientName,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "url": url == null ? null : url,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "title": title == null ? null : title,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "contentType": contentType == null ? null : contentType,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "couponDetails": couponDetails == null ? null : couponDetails.toJson(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "downloadExists": downloadExists == null ? null : downloadExists,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "bundle": bundle == null ? null : bundle,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "pixels": pixels == null ? null : pixels.toJson(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "logoUrl": logoUrl == null ? null : logoUrl,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "validPass": validPass == null ? null : validPass.toJson(),
        "paywallCustomization":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            paywallCustomization == null ? null : paywallCustomization.toJson(),
        "subscriptionsExist":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            subscriptionsExist == null ? null : subscriptionsExist,
        "subscriptionDomain":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            subscriptionDomain == null ? null : subscriptionDomain,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "pathUrl": pathUrl == null ? null : pathUrl,
        "categories": categories == null
            ? null
            : List<dynamic>.from(categories.map((x) => x)),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "detectedCountry": detectedCountry == null ? null : detectedCountry,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "couponForPass": couponForPass == null ? null : couponForPass.toJson(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "subscriptionUrl": subscriptionUrl == null ? null : subscriptionUrl,
      };
}

class Coupon {
  Coupon({
    required this.code,
    required this.newUsersOnly,
  });

  dynamic code;
  bool newUsersOnly;

  factory Coupon.fromJson(Map<String, dynamic> json) => Coupon(
        code: json["code"],
        newUsersOnly:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            json["newUsersOnly"] == null ? null : json["newUsersOnly"],
      );

  Map<String, dynamic> toJson() => {
        "code": code,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "newUsersOnly": newUsersOnly == null ? null : newUsersOnly,
      };
}

class MicroPricing {
  MicroPricing({
    required this.price,
    required this.duration,
  });

  int price;
  int duration;

  factory MicroPricing.fromJson(Map<String, dynamic> json) => MicroPricing(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        price: json["price"] == null ? null : json["price"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        duration: json["duration"] == null ? null : json["duration"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "price": price == null ? null : price,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "duration": duration == null ? null : duration,
      };
}

class PaywallCustomization {
  PaywallCustomization({
    required this.buttonStyle,
    required this.micropaymentDisplaytext,
    required this.subscriptionText,
    required this.subscriptionTitle,
    required this.crossButtonClickUrl,
    required this.brandLogoUrl,
  });

  ButtonStyle buttonStyle;
  String micropaymentDisplaytext;
  String subscriptionText;
  String subscriptionTitle;
  String crossButtonClickUrl;
  String brandLogoUrl;

  factory PaywallCustomization.fromJson(Map<String, dynamic> json) =>
      PaywallCustomization(
        buttonStyle: ButtonStyle.fromJson(json["buttonStyle"]),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        micropaymentDisplaytext: json["micropaymentDisplaytext"] == null
            ? null
            : json["micropaymentDisplaytext"],
        subscriptionText:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            json["subscriptionText"] == null ? null : json["subscriptionText"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        subscriptionTitle: json["subscriptionTitle"] == null
            ? null
            : json["subscriptionTitle"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        crossButtonClickUrl: json["crossButtonClickUrl"] == null
            ? null
            : json["crossButtonClickUrl"],
        brandLogoUrl:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            json["brandLogoUrl"] == null ? null : json["brandLogoUrl"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "buttonStyle": buttonStyle == null ? null : buttonStyle.toJson(),
        "micropaymentDisplaytext":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            micropaymentDisplaytext == null ? null : micropaymentDisplaytext,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "subscriptionText": subscriptionText == null ? null : subscriptionText,
        "subscriptionTitle":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            subscriptionTitle == null ? null : subscriptionTitle,
        "crossButtonClickUrl":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            crossButtonClickUrl == null ? null : crossButtonClickUrl,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "brandLogoUrl": brandLogoUrl == null ? null : brandLogoUrl,
      };
}

class ButtonStyle {
  ButtonStyle({
    required this.color,
  });

  String color;

  factory ButtonStyle.fromJson(Map<String, dynamic> json) => ButtonStyle(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        color: json["color"] == null ? null : json["color"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "color": color == null ? null : color,
      };
}

class Pixels {
  Pixels({
    required this.facebook,
  });

  Facebook facebook;

  factory Pixels.fromJson(Map<String, dynamic> json) => Pixels(
        facebook: Facebook.fromJson(json["facebook"]),
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "facebook": facebook == null ? null : facebook.toJson(),
      };
}

class Facebook {
  Facebook({
    required this.events,
  });

  List<dynamic> events;

  factory Facebook.fromJson(Map<String, dynamic> json) => Facebook(
        events: List<dynamic>.from(json["events"].map((x) => x)),
      );

  Map<String, dynamic> toJson() => {
        "events":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            events == null ? null : List<dynamic>.from(events.map((x) => x)),
      };
}

class ValidPass {
  ValidPass({
    required this.title,
    required this.price,
    required this.duration,
    required this.currency,
  });

  String title;
  int price;
  int duration;
  String currency;

  factory ValidPass.fromJson(Map<String, dynamic> json) => ValidPass(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        title: json["title"] == null ? null : json["title"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        price: json["price"] == null ? null : json["price"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        duration: json["duration"] == null ? null : json["duration"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        currency: json["currency"] == null ? null : json["currency"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "title": title == null ? null : title,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "price": price == null ? null : price,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "duration": duration == null ? null : duration,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "currency": currency == null ? null : currency,
      };
}
