class Embedded {
  String? title;
  List<Subscriptions>? subscriptions;

  Embedded({this.title, this.subscriptions});

  Embedded.fromJson(Map<String, dynamic> json) {
    title = json['title'];
    if (json['subscriptions'] != null) {
      subscriptions = <Subscriptions>[];
      json['subscriptions'].forEach((v) {
        subscriptions!.add(Subscriptions.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['title'] = title;
    if (subscriptions != null) {
      data['subscriptions'] = subscriptions!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class Subscriptions {
  FreeTrial? freeTrial;
  String? benefits;
  bool? physical;
  bool? digital;
  bool? adFree;
  bool? migrated;
  bool? couponsEnabled;
  String? adminCoupon;
  List<void>? usedCouponNumbers;
  String? sId;
  bool? recommended;
  bool? enabled;
  String? clientId;
  String? title;
  String? iconUrl;
  List<Tiers>? tiers;
  String? createdAt;
  String? updatedAt;
  int? iV;
  int? couponCount;
  String? currencySymbol;

  Subscriptions(
      {this.freeTrial,
      this.benefits,
      this.physical,
      this.digital,
      this.adFree,
      this.migrated,
      this.couponsEnabled,
      this.adminCoupon,
      this.usedCouponNumbers,
      this.sId,
      this.recommended,
      this.enabled,
      this.clientId,
      this.title,
      this.iconUrl,
      this.tiers,
      this.createdAt,
      this.updatedAt,
      this.iV,
      this.couponCount,
      this.currencySymbol});

  Subscriptions.fromJson(Map<String, dynamic> json) {
    freeTrial = json['freeTrial'] != null
        ? FreeTrial.fromJson(json['freeTrial'])
        : null;
    benefits = json['benefits'];
    physical = json['physical'];
    digital = json['digital'];
    adFree = json['adFree'];
    migrated = json['migrated'];
    couponsEnabled = json['couponsEnabled'];
    adminCoupon = json['adminCoupon'];
    if (json['usedCouponNumbers'] != null) {
      usedCouponNumbers = <Null>[];
      json['usedCouponNumbers'].forEach((v) {
        //  usedCouponNumbers!.add(new Null.fromJson(v));
      });
    }
    sId = json['_id'];
    recommended = json['recommended'];
    enabled = json['enabled'];
    clientId = json['clientId'];
    title = json['title'];
    iconUrl = json['iconUrl'];
    if (json['tiers'] != null) {
      tiers = <Tiers>[];
      json['tiers'].forEach((v) {
        tiers!.add(Tiers.fromJson(v));
      });
    }
    createdAt = json['createdAt'];
    updatedAt = json['updatedAt'];
    iV = json['__v'];
    couponCount = json['couponCount'];
    currencySymbol = json['currencySymbol'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    if (freeTrial != null) {
      data['freeTrial'] = freeTrial!.toJson();
    }
    data['benefits'] = benefits;
    data['physical'] = physical;
    data['digital'] = digital;
    data['adFree'] = adFree;
    data['migrated'] = migrated;
    data['couponsEnabled'] = couponsEnabled;
    data['adminCoupon'] = adminCoupon;
    if (usedCouponNumbers != null) {
      //  data['usedCouponNumbers'] =
      //    this.usedCouponNumbers!.map((v) => v.toJson()).toList();
    }
    data['_id'] = sId;
    data['recommended'] = recommended;
    data['enabled'] = enabled;
    data['clientId'] = clientId;
    data['title'] = title;
    data['iconUrl'] = iconUrl;
    if (tiers != null) {
      data['tiers'] = tiers!.map((v) => v.toJson()).toList();
    }
    data['createdAt'] = createdAt;
    data['updatedAt'] = updatedAt;
    data['__v'] = iV;
    data['couponCount'] = couponCount;
    data['currencySymbol'] = currencySymbol;
    return data;
  }
}

class FreeTrial {
  bool? enabled;
  int? duration;

  FreeTrial({this.enabled, this.duration});

  FreeTrial.fromJson(Map<String, dynamic> json) {
    enabled = json['enabled'];
    duration = json['duration'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = Map<String, dynamic>();
    data['enabled'] = enabled;
    data['duration'] = duration;
    return data;
  }
}

class Tiers {
  PriceOverrides? priceOverrides;
  String? currency;
  double? basePrice;
  List<Offers>? offers;
  String? sId;
  int? price;
  int? duration;

  Tiers(
      {this.priceOverrides,
      this.currency,
      this.basePrice,
      this.offers,
      this.sId,
      this.price,
      this.duration});

  Tiers.fromJson(Map<String, dynamic> json) {
    priceOverrides = json['priceOverrides'] != null
        ? PriceOverrides.fromJson(json['priceOverrides'])
        : null;
    currency = json['currency'];
    basePrice = json['basePrice'].toDouble();
    if (json['offers'] != null) {
      offers = <Offers>[];
      json['offers'].forEach((v) {
        offers!.add(Offers.fromJson(v));
      });
    }
    sId = json['_id'];
    price = json['price'];
    duration = json['duration'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = Map<String, dynamic>();
    if (priceOverrides != null) {
      data['priceOverrides'] = priceOverrides!.toJson();
    }
    data['currency'] = currency;
    data['basePrice'] = basePrice;
    if (offers != null) {
      data['offers'] = offers!.map((v) => v.toJson()).toList();
    }
    data['_id'] = sId;
    data['price'] = price;
    data['duration'] = duration;
    return data;
  }
}

class PriceOverrides {
  List<void>? country;

  PriceOverrides({this.country});

  PriceOverrides.fromJson(Map<String, dynamic> json) {
    if (json['country'] != null) {
      country = <Null>[];
      json['country'].forEach((v) {
        //  country!.add(Null.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    if (country != null) {
      //data['country'] = this.country!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class Offers {
  String? sId;
  String? title;
  String? benefits;
  String? iconUrl;

  Offers({this.sId, this.title, this.benefits, this.iconUrl});

  Offers.fromJson(Map<String, dynamic> json) {
    sId = json['_id'];
    title = json['title'];
    benefits = json['benefits'];
    iconUrl = json['iconUrl'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['_id'] = sId;
    data['title'] = title;
    data['benefits'] = benefits;
    data['iconUrl'] = iconUrl;
    return data;
  }
}
