// To parse this JSON data, do
//
//     final embeddedSubscribtion = embeddedSubscribtionFromJson(jsonString);

import 'dart:convert';

EmbeddedSubscribtion embeddedSubscribtionFromJson(String str) =>
    EmbeddedSubscribtion.fromJson(json.decode(str));

String embeddedSubscribtionToJson(EmbeddedSubscribtion data) =>
    json.encode(data.toJson());

class EmbeddedSubscribtion {
  EmbeddedSubscribtion({
    required this.title,
    required this.subscriptions,
    required this.recommended,
  });

  String title;
  List<Subscription> subscriptions;
  String recommended;

  factory EmbeddedSubscribtion.fromJson(Map<String, dynamic> json) =>
      EmbeddedSubscribtion(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        title: json["title"] == null ? null : json["title"],
        subscriptions: List<Subscription>.from(
            json["subscriptions"].map((x) => Subscription.fromJson(x))),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        recommended: json["recommended"] == null ? null : json["recommended"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "title": title == null ? null : title,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "subscriptions": subscriptions == null
            ? null
            : List<dynamic>.from(subscriptions.map((x) => x.toJson())),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "recommended": recommended == null ? null : recommended,
      };
}

class Subscription {
  Subscription({
    required this.freeTrial,
    required this.benefits,
    required this.physical,
    required this.digital,
    required this.adFree,
    required this.migrated,
    required this.couponsEnabled,
    required this.adminCoupon,
    required this.usedCouponNumbers,
    required this.id,
    required this.recommended,
    required this.enabled,
    required this.clientId,
    required this.title,
    required this.iconUrl,
    required this.tiers,
    required this.createdAt,
    required this.updatedAt,
    required this.v,
    required this.couponCount,
    required this.currencySymbol,
  });

  FreeTrial freeTrial;
  String benefits;
  bool physical;
  bool digital;
  bool adFree;
  bool migrated;
  bool couponsEnabled;
  String adminCoupon;
  List<dynamic> usedCouponNumbers;
  String id;
  bool recommended;
  bool enabled;
  String clientId;
  String title;
  String iconUrl;
  List<Tier> tiers;
  DateTime createdAt;
  DateTime updatedAt;
  int v;
  int couponCount;
  String currencySymbol;

  factory Subscription.fromJson(Map<String, dynamic> json) => Subscription(
        freeTrial: FreeTrial.fromJson(json["freeTrial"]),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        benefits: json["benefits"] == null ? null : json["benefits"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        physical: json["physical"] == null ? null : json["physical"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        digital: json["digital"] == null ? null : json["digital"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        adFree: json["adFree"] == null ? null : json["adFree"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        migrated: json["migrated"] == null ? null : json["migrated"],
        couponsEnabled:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            json["couponsEnabled"] == null ? null : json["couponsEnabled"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        adminCoupon: json["adminCoupon"] == null ? null : json["adminCoupon"],
        usedCouponNumbers:
            List<dynamic>.from(json["usedCouponNumbers"].map((x) => x)),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        id: json["_id"] == null ? null : json["_id"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        recommended: json["recommended"] == null ? null : json["recommended"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        enabled: json["enabled"] == null ? null : json["enabled"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        clientId: json["clientId"] == null ? null : json["clientId"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        title: json["title"] == null ? null : json["title"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        iconUrl: json["iconUrl"] == null ? null : json["iconUrl"],
        tiers: List<Tier>.from(json["tiers"].map((x) => Tier.fromJson(x))),
        createdAt: DateTime.parse(json["createdAt"]),
        updatedAt: DateTime.parse(json["updatedAt"]),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        v: json["__v"] == null ? null : json["__v"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        couponCount: json["couponCount"] == null ? null : json["couponCount"],
        currencySymbol:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison
            json["currencySymbol"] == null ? null : json["currencySymbol"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "freeTrial": freeTrial == null ? null : freeTrial.toJson(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "benefits": benefits == null ? null : benefits,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "physical": physical == null ? null : physical,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "digital": digital == null ? null : digital,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "adFree": adFree == null ? null : adFree,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "migrated": migrated == null ? null : migrated,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "couponsEnabled": couponsEnabled == null ? null : couponsEnabled,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "adminCoupon": adminCoupon == null ? null : adminCoupon,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "usedCouponNumbers": usedCouponNumbers == null
            ? null
            : List<dynamic>.from(usedCouponNumbers.map((x) => x)),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "_id": id == null ? null : id,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "recommended": recommended == null ? null : recommended,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "enabled": enabled == null ? null : enabled,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "clientId": clientId == null ? null : clientId,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "title": title == null ? null : title,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "iconUrl": iconUrl == null ? null : iconUrl,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison
        "tiers": tiers == null
            ? null
            : List<dynamic>.from(tiers.map((x) => x.toJson())),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "createdAt": createdAt == null ? null : createdAt.toIso8601String(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "updatedAt": updatedAt == null ? null : updatedAt.toIso8601String(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "__v": v == null ? null : v,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "couponCount": couponCount == null ? null : couponCount,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "currencySymbol": currencySymbol == null ? null : currencySymbol,
      };
}

class FreeTrial {
  FreeTrial({
    required this.enabled,
    required this.duration,
  });

  bool enabled;
  dynamic duration;

  factory FreeTrial.fromJson(Map<String, dynamic> json) => FreeTrial(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        enabled: json["enabled"] == null ? null : json["enabled"],
        duration: json["duration"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "enabled": enabled == null ? null : enabled,
        "duration": duration,
      };
}

class Tier {
  Tier({
    required this.priceOverrides,
    required this.currency,
    required this.basePrice,
    required this.offers,
    required this.id,
    required this.price,
    required this.duration,
  });

  PriceOverrides priceOverrides;
  String currency;
  double basePrice;
  List<Offer> offers;
  String id;
  double price;
  int duration;

  factory Tier.fromJson(Map<String, dynamic> json) => Tier(
        priceOverrides: PriceOverrides.fromJson(json["priceOverrides"]),
        currency: json["currency"],
        basePrice:
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            json["basePrice"] == null ? null : json["basePrice"].toDouble(),
        offers: List<Offer>.from(json["offers"].map((x) => Offer.fromJson(x))),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        id: json["_id"] == null ? null : json["_id"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        price: json["price"] == null ? null : json["price"].toDouble(),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        duration: json["duration"] == null ? null : json["duration"],
      );

  Map<String, dynamic> toJson() => {
        "priceOverrides":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            priceOverrides == null ? null : priceOverrides.toJson(),
        "currency": [currency],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "basePrice": basePrice == null ? null : basePrice,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "offers": offers == null
            ? null
            : List<dynamic>.from(offers.map((x) => x.toJson())),
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "_id": id == null ? null : id,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "price": price == null ? null : price,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "duration": duration == null ? null : duration,
      };
}

// enum Currency { INR }

// final currencyValues = EnumValues({"INR": Currency.INR});

class Offer {
  Offer({
    required this.id,
    required this.title,
    required this.benefits,
    required this.iconUrl,
  });

  String id;
  String title;
  String benefits;
  String iconUrl;

  factory Offer.fromJson(Map<String, dynamic> json) => Offer(
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        id: json["_id"] == null ? null : json["_id"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        title: json["title"] == null ? null : json["title"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        benefits: json["benefits"] == null ? null : json["benefits"],
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        iconUrl: json["iconUrl"] == null ? null : json["iconUrl"],
      );

  Map<String, dynamic> toJson() => {
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "_id": id == null ? null : id,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "title": title == null ? null : title,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "benefits": benefits == null ? null : benefits,
        // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
        "iconUrl": iconUrl == null ? null : iconUrl,
      };
}

class PriceOverrides {
  PriceOverrides({
    required this.country,
  });

  List<dynamic> country;

  factory PriceOverrides.fromJson(Map<String, dynamic> json) => PriceOverrides(
        country: List<dynamic>.from(json["country"].map((x) => x)),
      );

  Map<String, dynamic> toJson() => {
        "country":
            // ignore: prefer_if_null_operators, unnecessary_null_comparison, prefer_null_aware_operators
            country == null ? null : List<dynamic>.from(country.map((x) => x)),
      };
}

class EnumValues<T> {
  // EnumValues(Map<String, Currency> map);

  // Map<String, T> map;
  // Map<T, String> reverseMap;

  // EnumValues(this.map);

  // Map<T, String> get reverse {
  //   if (reverseMap == null) {
  //     reverseMap = map.map((k, v) => new MapEntry(v, k));
  //   }
  //   return reverseMap;
  // }

}
